--- Sconstruct.orig	2009-09-07 16:31:13.000000000 -0500
+++ Sconstruct	2010-05-06 15:56:51.000000000 -0500
@@ -41,9 +41,9 @@
 
 
 def get_platform_flags( opts ):
-	includes = []
+	includes = [ '@PREFIX@/include' ]
 	cppflags = []
-	ldflags = []
+	ldflags = [ '@LDFLAGS@' ]
 
 	env = Environment( options = opts )
 
@@ -70,6 +70,7 @@
                 if str(env['flac']) == "1": cppflags.append('-DFLAC_SUPPORT')
 		
 		if sys.platform == "darwin" and str(env['coreaudio']) == "1": cppflags.append('-DCOREAUDIO_SUPPORT')
+		if sys.platform == "darwin" and str(env['coremidi']) == "1": cppflags.append('-DCOREMIDI_SUPPORT')
 
 		cppflags.append('-DLADSPA_SUPPORT')
 		
@@ -81,9 +82,6 @@
 	includes.append( 'gui/src/' )
 	includes.append( '3rdparty/install/include' )
 
-	if sys.platform == "darwin":
-		ldflags.append( '-L/opt/local/lib' )
-
 	if sys.platform == 'linux2':
 		ldflags.append('-lasound')
 
@@ -93,7 +91,7 @@
 		includes.append( '3rdparty\libarchive\include' )
 		includes.append( 'windows\timeFix' )
 		includes.append( 'C:\Program Files\GnuWin32\include' )
-	else:
+	elif sys.platform != 'darwin':
 		raise Exception( "Platform '%s' not supported" % sys.platform )
 
 	return (includes, cppflags, ldflags)
@@ -275,8 +273,10 @@
 	if sys.platform == "darwin" and str(env['coreaudio']) == "1":
 		env.Append( LINKFLAGS = ['-framework','ApplicationServices'])
 		env.Append( LINKFLAGS = ['-framework','AudioUnit'])
-		env.Append( LINKFLAGS = ['-framework','Coreaudio'])
+		env.Append( LINKFLAGS = ['-framework','CoreAudio'])
 
+	if sys.platform == "darwin" and str(env['coremidi']) == "1":
+		env.Append( LINKFLAGS = ['-framework','CoreMIDI'])
 
 
 	app = env.Program(target = 'hydrogen', source = src )
@@ -318,7 +318,7 @@
         rv = "-DJACK_NO_BBT_OFFSET"
     xenv.MergeFlags(rv)
 
-opts = Options('scache.conf')
+opts = Variables('scache.conf')
 
 #platform independent settings
 opts.Add('debug', 'Set to 1 to build with debug informations', 0)
@@ -329,9 +329,18 @@
 
 #platform dependent settings
 if sys.platform == "darwin":
-	opts.Add('coreaudio', 'Set to 1 to enable Coreaudio',1)
+	opts.Add('coreaudio', 'Set to 1 to enable CoreAudio',1)
+	opts.Add('coremidi', 'Set to 1 to enable CoreMIDI',1)
+	opts.Add('portmidi', 'Set to 1 to enable portmidi',0)
+	opts.Add('portaudio', 'Set to 1 to enable portaudio',0)
+	opts.Add('oss', 'Set to 1 to enable oss',0)
+	opts.Add('alsa', 'Set to 1 to enable alsa',0)
+	opts.Add('jack', 'Set to 1 to enable jack',0)
+	opts.Add('flac', 'Set to 1 to enable flac',1)
+	opts.Add('lash', 'Set to 1 to enable lash',0)
+	opts.Add('lrdf', 'Set to 1 to enable lrdf',0)
 
-if sys.platform != "win32":
+elif sys.platform != "win32":
 	opts.Add('oss', 'Set to 1 to enable oss',1)
 
 	opts.Add('portmidi', 'Set to 1 to enable portmidi',0)
@@ -474,7 +483,7 @@
 
 
 print "      lash: " + printStatus( env["lash"] )
-print "      oss: " + printStatus( env["oss"] )
+print "       oss: " + printStatus( env["oss"] )
 print "      alsa: " + printStatus( env["alsa"] )
 print "      jack: " + printStatus( env["jack"] )
 print "libarchive: " + printStatus( env["libarchive"] ) 
@@ -482,6 +491,7 @@
 print "  portmidi: " + printStatus( env["portmidi"] ) 
 if sys.platform == "darwin":
 	print " coreaudio: " + printStatus( env["coreaudio"] )
+	print "  coremidi: " + printStatus( env["coremidi"] )
 
 print "\n================================================================="
 print ""
